﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ListView2图片副本
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //MessageBox.Show((GetImages() == null).ToString());
            listView1.View = View.LargeIcon;
            listView1.MultiSelect = false;

            string[] files = GetImages();
            if (files != null)
            {
                ImageList list = GetImage(files);
                if (listView1.LargeImageList == null)
                {
                    listView1.LargeImageList = new ImageList();
                    listView1.LargeImageList.ImageSize = new Size(60, 80);
                }
                for (int i = 0; i < list.Images.Count; i++)
                {
                    listView1.LargeImageList.Images.Add(list.Images.Keys[i], list.Images[i]);
                }

                int count = listView1.Items.Count;
                if (files.Length == list.Images.Count)
                {
                    for (int i = count; i < count + files.Length; i++)
                    {
                        int index = i - count;
                        FileInfo info = new FileInfo(files[index]);
                        //ListViewItem item = new ListViewItem(info.Name, i);
                        //item.Name = info.FullName;

                        if (!listView1.Items.ContainsKey(files[index]))
                        {
                            listView1.Items.Add(files[index], info.Name, i);
                        }
                        else
                        {
                            //listView1.LargeImageList.Images.RemoveByKey(files[index]);//用不着这一句
                            MessageBox.Show("已存在此图片：" + files[index] + "，不能重复添加！");
                        }
                    }
                    //listView1.LargeImageList = list;
                }
            }
        }

        private ImageList GetImage(string[] files)
        {
            ImageList list = new ImageList();
            for (int i = 0; i < files.Length; i++)
            {
                //Image image = Image.FromFile(files[i]);
                list.Images.Add(files[i], Image.FromFile(files[i]));
                list.ImageSize = new Size(60, 80);
            }
            return list;
        }

        private string[] GetImages()
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Multiselect = true;//设置 选择多个文件
            ofd.InitialDirectory = @"G:\images\";//设置初始目录  TODO:改为系统默认我的文档中的图片文件夹
            ofd.Multiselect = true;
            //ofd.Filter = "JPG(*.jpg)|*.jpg|JPEG(*.jpeg)|*.jpeg|PNG(*.png)|*.png|GIF(*.gif)|*.gif|所有文件(*.*)|*.*";
            ofd.Filter = "图片文件(*.jpg *.jpeg *.gif *.png)|*.jpg;*.jpeg;*.gif;*.png";
            if (ofd.ShowDialog() == DialogResult.OK && ofd.FileNames != null)
            {
                string[] files = ofd.FileNames;
                return files;
            }
            else
            {
                return null;
            }
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count == 1)
            {
                pictureBox1.Image = Image.FromFile(listView1.SelectedItems[0].Name);
                //MessageBox.Show(listView1.SelectedItems[0].Name);
            }
        }
    }
}
